#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <assert.h>
#include <string.h>

char prompt[] = "rev> ";
int promptlen = sizeof(prompt) - 1;
char *input[] = { "adam", "word", "revert", NULL };
char *output[] = { "mada", "drow", "trever", NULL };

int
main(int argc, char **argv)
{
	int ip[2], op[2];
	pid_t pid;
	int i;
	FILE *ifile, *ofile;
	char buf[128];
	
	assert(argc > 1);
	argc--;
	argv++;
	assert(pipe(ip) == 0);
	assert(pipe(op) == 0);

	pid = fork();
	assert(pid != -1);

	if (pid == 0) {
		/* ip[0] - child stdin
		   ip[1] - master write
		   op[0] - master read
		   op[1] - child stdout
		*/
		close(ip[1]);
		close(op[0]);
		if (ip[0] != 0) {
			close(0);
			dup(ip[0]);
			close(ip[0]);
		}
		if (op[1] != 1) {
			close(1);
			dup(op[1]);
			close(op[1]);
		}
		execvp(argv[0], argv);
		perror(argv[0]);
		_exit(127);
	}
	/* master */
	close(ip[0]);
	close(op[1]);
	ifile = fdopen(op[0], "r");
	if (!ifile) {
		perror("op[0]");
		abort();
	}
	setlinebuf(ifile);
	ofile = fdopen(ip[1], "w");
	if (!ofile) {
		perror("ip[1]");
		abort();
	}
	setlinebuf(ofile);
	for (i = 0; input[i]; i++) {
		alarm(5);
		if (fread(buf, promptlen, 1, ifile) != 1) {
			fprintf(stderr, "%d: read error\n", __LINE__);
			abort();
		}
		alarm(0);

		if (strncmp(buf, prompt, promptlen)) {
			fprintf(stderr, "%d: expected prompt, but got \"%*.*s\"\n",
				__LINE__, promptlen, promptlen, buf);
			abort();
		}

		fprintf(ofile, "%s\n", input[i]);

		alarm(5);
		if (!fgets(buf, sizeof(buf), ifile)) {
			fprintf(stderr, "%d: read error\n", __LINE__);
			abort();
		}
		alarm(0);
		buf[strlen(buf)-1] = 0;
		if (strcmp(buf, output[i])) {
			fprintf(stderr, "%d: expected \"%s\", but got \"%s\"\n",
				__LINE__, output[i], buf);
			abort();
		}
	}
	return 0;
}
		
